B2Shape = Core.class()

-- converting array to vertices list
function B2Shape:verticesConvert(tb, i)
	
	if tb[i] ~= nil then
		return tb[i].x, tb[i].y, self:verticesConvert(tb, i + 1)
	end

end

-- return rectangle shape
function B2Shape:rectangle(obj, x, y, a)
	
	x = x or 0
	y = y or 0
	a = a or 0
	
	local shape = b2.PolygonShape.new()
	shape:setAsBox(obj.width / 2, obj.height / 2, x, y, a)
	return shape
	
end

-- return polygon shape
function B2Shape:polygon(obj)
	
	local vertics	= obj.polygon
	local shape		= b2.PolygonShape.new()
	shape:set(self:verticesConvert(vertics, 1))
	return shape
	
end

-- return polyline shape
function B2Shape:polyline(obj)
	
	local vertics	= obj.polyline
	local shape		= b2.ChainShape.new()
	shape:createChain(self:verticesConvert(vertics, 1))
	return shape
	
end

-- return ellipse shape
function B2Shape:ellipse(obj, x, y)
	
	x = x or 0
	y = y or 0
	
	local shape		= b2.CircleShape.new(x, y, obj.width / 2)
	return shape
	
end