ObjectBase = Core.class(Sprite)

function ObjectBase:init(obj, world)
	
	self.id			= obj.id
	self.type		= obj.type
	self.shape		= obj.shape
    self.width		= obj.width
    self.height		= obj.height
	self.rotation	= obj.rotation
	self.vertices	= obj.polyline or obj.polygon
	self.properties	= obj.properties
	
	self.x			= obj.x + obj.width / 2
	self.y			= obj.y + obj.height / 2
	
	self.world		= world
	self.interact	= interact or nil
	
end

function ObjectBase:parseProperty(propValue)
	
	return tonumber(propValue) or propValue
	
end

function ObjectBase:assignProperties(properties, defaults)
	
	for propName, propValue in pairs(defaults) do
		
		properties[propName] = self:parseProperty(properties[propName]) or propValue
		
	end
	
	return properties
	
end